#include<bits/stdc++.h>
using namespace std ;

int main() {
    ios_base::sync_with_stdio(false) ;
    cin.tie(0) ;
    cout.tie(0) ;
    int t ;
    cin >> t ;
    vector<long long> niz(t) ;
    for (int i = 0 ; i < t ; i++) {
        cin >> niz[i] ;
    }
    sort(niz.begin(),niz.end()) ;
    set<long long> proizvodi ;
    for (int i = 1 ; i <= niz[t-1] ; i++) {
        string x = to_string(i) ;
        long long p = 1 ;
        for (int j = 0 ; j < x.size() ; j++) {
            if (int(x[j])-48 == 0) {
                p = 0 ;
                proizvodi.insert(0) ;
                break ;
            }
            p *= (int(x[j])-48) ;
        }
        proizvodi.insert(p) ;
        if (i == niz[0]) {
            cout << proizvodi.size() << endl ;
            niz.erase(niz.begin()) ;
        }
    }
}